/*
 * GrammarAccess.h
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#ifndef GRAMMAR_ACCESS_H_
#define GRAMMAR_ACCESS_H_

#include <core/multipleDispatch.hpp>

#include "grammar/Grammar.h"
#include "grammar/GrammarFeatures.h"

#include "settings/GrammarSettings.h"
#include "settings/OperationSettings.h"
#include <set>

class GrammarAccess : public std::SingleDispatch < GrammarAccess, void, grammar::GrammarBase &, const GrammarSettings::Settings &, const OperationSettings::Settings &, std::deque < sax::Token > & > {
public:
	static void access ( grammar::Grammar & grammar, const GrammarSettings::Settings & settings, const OperationSettings::Settings & operation, std::deque < sax::Token > & argument );

	static void access ( grammar::RightRG < > & grammar, const GrammarSettings::Settings & settings, const OperationSettings::Settings & operation, std::deque < sax::Token > & argument );
	static void access ( grammar::RightLG < > & grammar, const GrammarSettings::Settings & settings, const OperationSettings::Settings & operation, std::deque < sax::Token > & argument );
};

#endif /* GRAMMAR_ACCESS_H_ */
