/*
 * AutomatonSettings.h
 *
 *  Created on: 26. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef __AUTOMATA_SETTINGS_H__
#define __AUTOMATA_SETTINGS_H__

#include "SettingsHelper.h"

class AutomatonEnum {
public:
	enum class Settings {
		STATES, FINAL_STATES, INITIAL_STATES, INPUT_ALPHABET, TRANSITIONS, EPSILON_TRANSITIONS,	READING_TRANSITIONS, __MAX__
	};

	static std::string toString ( AutomatonEnum::Settings settings ) {
		switch ( settings ) {
		case AutomatonEnum::Settings::STATES:
			return "states";

		case AutomatonEnum::Settings::FINAL_STATES:
			return "final_states";

		case AutomatonEnum::Settings::INITIAL_STATES:
			return "initial_states";

		case AutomatonEnum::Settings::INPUT_ALPHABET:
			return "input_alphabet";

		case AutomatonEnum::Settings::TRANSITIONS:
			return "transitions";

		case AutomatonEnum::Settings::EPSILON_TRANSITIONS:
			return "epsilon_transitions";

		case AutomatonEnum::Settings::READING_TRANSITIONS:
			return "reading_transitions";

		case AutomatonEnum::Settings::__MAX__:
			throw exception::CommonException ( "Invalid enumeration" );
		}
		throw exception::CommonException ( "Invalid enumeration" );
	}

};

class AutomatonSettings : public AutomatonEnum, public EnumClassHelper < AutomatonEnum > {
};

#endif /* __AUTOMATA_SETTINGS_H__ */
