/*
 * ToGrammarRightRG.h
 *
 *  Created on: 9. 2. 2014
 *      Author: Tomas Pecka
 */

#ifndef __TO_GRAMMAR_RIGHT_RG_H__
#define __TO_GRAMMAR_RIGHT_RG_H__

#include <core/multipleDispatch.hpp>

#include <grammar/Regular/RightRG.h>
#include <automaton/FSM/NFA.h>
#include <automaton/FSM/DFA.h>

#include <automaton/Automaton.h>

namespace automaton {

namespace convert {

/**
 * Finite automaton to right regular grammar converter.
 * Source: Melichar 2.104
 */
class ToGrammarRightRG : public std::SingleDispatch<ToGrammarRightRG, grammar::RightRG < >, const automaton::AutomatonBase &> {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static grammar::RightRG < > convert(const automaton::Automaton& automaton);

	static grammar::RightRG < > convert(const automaton::NFA < > & automaton);
	static grammar::RightRG < > convert(const automaton::DFA<>& automaton);
};

} /* namespace convert */

} /* namespace automaton */

#endif /* __TO_GRAMMAR_RIGHT_RG_H__ */
