/*
 * Normalize.h
 *
 *  Created on: Dec 9, 2013
 *	  Author: Jan Travnicek
 */

#ifndef NORMALIZE_H_
#define NORMALIZE_H_

#include <core/multipleDispatch.hpp>
#include <automaton/FSM/DFA.h>
#include <automaton/PDA/DPDA.h>
#include <automaton/Automaton.h>

namespace automaton {

namespace simplify {

class Normalize : public std::SingleDispatch<Normalize, automaton::Automaton, const automaton::AutomatonBase &> {
public:
	/**
	 * @param dfa automaton to normalize
	 */
	static automaton::Automaton normalize(const automaton::Automaton& dfa);

	static automaton::DFA<> normalize(const automaton::DFA<>& dfa);
	static automaton::DPDA < > normalize(const automaton::DPDA < > & dfa);
};

} /* namespace simplify */

} /* namespace automaton */

#endif /* NORMALIZE_H_ */
