/*
 * SingleInitialState.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Tomas Pecka
 */

#include "SingleInitialState.h"

namespace automaton {

namespace simplify {

automaton::Automaton SingleInitialState::convert(const Automaton& automaton) {
	return dispatch(automaton.getData());
}

auto SingleInitialStateMultiInitialStateNFA = SingleInitialState::RegistratorWrapper<automaton::NFA < >, automaton::MultiInitialStateNFA < > >(SingleInitialState::convert);
auto SingleInitialStateDFA = SingleInitialState::RegistratorWrapper<automaton::DFA < >, automaton::DFA < > >(SingleInitialState::convert);
auto SingleInitialStateEpsilonNFA = SingleInitialState::RegistratorWrapper<automaton::EpsilonNFA < >, automaton::EpsilonNFA < > >(SingleInitialState::convert);
auto SingleInitialStateNFA = SingleInitialState::RegistratorWrapper<automaton::NFA < > , automaton::NFA < > >(SingleInitialState::convert);
auto SingleInitialStateCompactNFA = SingleInitialState::RegistratorWrapper<automaton::CompactNFA < >, automaton::CompactNFA < > >(SingleInitialState::convert);
auto SingleInitialStateExtendedNFA = SingleInitialState::RegistratorWrapper<automaton::ExtendedNFA < >, automaton::ExtendedNFA < > >(SingleInitialState::convert);

} /* namespace simplify */

} /* namespace automaton */
