/*
 * AutomataUnionCartesianProduct.h
 *
 *  Created on: 20. 11. 2014
 *	  Author: Tomas Pecka
 */

#ifndef AUTOMATA_UNION_CARTESIAN_H_
#define AUTOMATA_UNION_CARTESIAN_H_

#include <core/multipleDispatch.hpp>
#include <automaton/Automaton.h>
#include <automaton/FSM/EpsilonNFA.h>

namespace automaton {

namespace transform {

/**
 * Union two automata.
 *  - For finite automata A1, A2, we create automaton L accepting L(A1) \cup L(A2) (Melichar, 2.71)
 */
class AutomataUnionCartesianProduct : public std::PromotingDoubleDispatch<AutomataUnionCartesianProduct, automaton::Automaton, const automaton::AutomatonBase &> {
public:
	static automaton::Automaton unification(const automaton::Automaton& first, const automaton::Automaton& second);

	static automaton::NFA < > unification(const automaton::NFA < > & first, const automaton::NFA < > & second);
	static automaton::DFA<> unification(const automaton::DFA<>& first, const automaton::DFA<>& second);
};

} /* namespace transform */

} /* namespace automaton */

#endif /* AUTOMATA_UNION_CARTESIAN_H_ */
