/*
 * RegExpDerivation.cpp
 *
 *  Created on: 19. 1. 2014
 *	  Author: Tomas Pecka
 */

#include "RegExpDerivation.h"

namespace regexp {

regexp::RegExp RegExpDerivation::derivation(const regexp::RegExp& regexp, const string::LinearString < >& string) {
	return dispatch(regexp.getData(), string);
}

auto RegExpDerivationFormalRegExp = RegExpDerivation::RegistratorWrapper<regexp::FormalRegExp < >, regexp::FormalRegExp < > >(RegExpDerivation::derivation);
auto RegExpDerivationUnboundedRegExp = RegExpDerivation::RegistratorWrapper<regexp::UnboundedRegExp < >, regexp::UnboundedRegExp < > >(RegExpDerivation::derivation);

} /* namespace regexp */
