/*
 * ExactCompare.cpp
 *
 *  Created on: Oct 9, 2014
 *	  Author: Radomir Polach */

#include "ExactCompare.h"

#include "string/LinearString.h"
#include "string/CyclicString.h"
#include "string/Epsilon.h"

namespace string {

namespace naive {

int ExactCompare::compare ( const string::String & u, const string::String & v ) {
	return dispatch ( u.getData ( ), v.getData ( ) );
}

auto ExactCompareEpsilon = ExactCompare::RegistratorWrapper < int, string::Epsilon < > > ( ExactCompare::compare );
auto ExactCompareLinearString = ExactCompare::RegistratorWrapper < int, string::LinearString < > > ( ExactCompare::compare );
auto ExactCompareCyclicString = ExactCompare::RegistratorWrapper < int, string::CyclicString < > > ( ExactCompare::compare );

} /* namespace naive */

} /* namespace string */
