/*
 * ExactFactorAutomaton.cpp
 *
 *  Created on: 7. 4. 2015
 *      Author: Jan Travnicek
 */

#include "ExactFactorAutomaton.h"
#include <string/LinearString.h>
#include <string/Epsilon.h>

#include <deque>

namespace stringology {

namespace exact {

automaton::Automaton ExactFactorAutomaton::construct(const string::String& text) {
	return dispatch(text.getData());
}

automaton::EpsilonNFA < > ExactFactorAutomaton::construct(const string::LinearString < >& text) {
	automaton::EpsilonNFA < > res(DefaultStateType(0));
	res.addFinalState(DefaultStateType(0));
	res.setInputAlphabet(text.getAlphabet());
	int i = 1;
	for(const DefaultSymbolType& symbol : text.getContent()) {
		res.addState(DefaultStateType(i));
		res.addFinalState(DefaultStateType(i));
		res.addTransition(DefaultStateType(i-1), symbol, DefaultStateType(i));
		res.addTransition(DefaultStateType(0), DefaultStateType(i));
		i++;
	}
	return res;
}

auto ExactFactorAutomatonLinearString = ExactFactorAutomaton::RegistratorWrapper<automaton::EpsilonNFA < >, string::LinearString < >>(ExactFactorAutomaton::construct);

} /* namespace exact */

} /* namespace stringology */
