/*
 * Edmonds.h
 *
 *   Created on: Apr 7, 2016
 *       Author: Jan Broz
 */

#ifndef GRAPH_EDMONDS
#define GRAPH_EDMONDS

#include <core/multipleDispatch.hpp>
#include <graph/GraphClasses.h>

namespace graph {

namespace spanningtree {

class Edmonds : public std::SingleDispatch< Edmonds, graph::Graph, const graph::GraphBase & > {
public:

	static Graph edmonds( const Graph & graph );

	static AdjacencyListDirectedGraph edmonds( const DirectedGraph & graph );

	static Edmonds & getInstance() {
		static Edmonds res;
		return res;
	}

};

} // spanningtree

} // graph

#endif // GRAPH_EDMONDS
