/*
 * ExtendedNFA.cpp
 *
 *  Created on: Mar 25, 2013
 *      Author: Jan Travnicek
 */

#include "ExtendedNFA.h"
#include "../Automaton.h"
#include <object/Object.h>
#include <core/xmlApi.hpp>

#include <core/castApi.hpp>

namespace alib {

auto extendedNFAParserRegister = xmlApi < automaton::Automaton >::ParserRegister < automaton::ExtendedNFA < > > ( );
auto extendedNFAParserRegister2 = xmlApi < alib::Object >::ParserRegister < automaton::ExtendedNFA < > > ( );

auto ExtendedNFAFromDFA = castApi::CastRegister < automaton::ExtendedNFA < >, automaton::DFA < > > ( );
auto ExtendedNFAFromNFA = castApi::CastRegister < automaton::ExtendedNFA < >, automaton::NFA < > > ( );
auto ExtendedNFAFromMultiInitialStateNFA = castApi::CastRegister < automaton::ExtendedNFA < >, automaton::MultiInitialStateNFA < > > ( );
auto ExtendedNFAEpsilonNFA = castApi::CastRegister < automaton::ExtendedNFA < >, automaton::EpsilonNFA < > > ( );
auto ExtendedNFACompactNFA = castApi::CastRegister < automaton::ExtendedNFA < >, automaton::CompactNFA < > > ( );
auto ExtendedNFACastBinder = castApi::CastPoolStringBinder < automaton::ExtendedNFA < > > ( automaton::ExtendedNFA < >::getXmlTagName() );

} /* namespace alib */
