/*
 * Label.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#ifndef LABEL_H_
#define LABEL_H_

#include <base/WrapperBase.hpp>
#include "LabelBase.h"

#include <set>
#include <alphabet/SymbolFeatures.h>

namespace label {

/**
 * Wrapper around automata.
 */
class Label : public alib::WrapperBase < LabelBase > {
	using alib::WrapperBase < LabelBase >::WrapperBase;

public:
	explicit Label ( const alphabet::Symbol & );
	explicit Label ( alphabet::Symbol && );
	explicit Label ( label::Label label1, label::Label label2 );
	explicit Label ( int number );
	explicit Label ( int number1, int number2 );
	explicit Label ( char character );
	explicit Label ( std::string string );
	explicit Label ( const char * string );

	void inc ( );

};

} /* namespace label */

#endif /* LABEL_H_ */
