/*
 * EpsilonRemoverOutgoing.cpp
 *
 *  Created on: 16. 1. 2014
 *	  Author: Jan Travnicek
 */

#include "EpsilonRemoverOutgoing.h"

namespace automaton {

namespace simplify {

namespace efficient {

auto EpsilonRemoverOutgoingDFA = EpsilonRemoverOutgoing::RegistratorWrapper < automaton::DFA < >, automaton::DFA < > > ( EpsilonRemoverOutgoing::remove );
auto EpsilonRemoverOutgoingMultiInitialStateNFA = EpsilonRemoverOutgoing::RegistratorWrapper < automaton::MultiInitialStateNFA < >, automaton::MultiInitialStateNFA < > > ( EpsilonRemoverOutgoing::remove );
auto EpsilonRemoverOutgoingNFA = EpsilonRemoverOutgoing::RegistratorWrapper < automaton::NFA < >, automaton::NFA < > > ( EpsilonRemoverOutgoing::remove );
auto EpsilonRemoverOutgoingEpsilonNFA = EpsilonRemoverOutgoing::RegistratorWrapper < automaton::MultiInitialStateNFA < >, automaton::EpsilonNFA < > > ( EpsilonRemoverOutgoing::remove );

automaton::Automaton EpsilonRemoverOutgoing::remove ( const automaton::Automaton& automaton ) {
	return dispatch ( automaton.getData ( ) );
}

} /*namespace efficient */

} /* namespace simplify */

} /* namespace automaton */
