/*
 * Author: Radovan Cerveny
 */

#ifndef MEASUREMENT_PROCESSOR_VIEWS_HPP_
#define MEASUREMENT_PROCESSOR_VIEWS_HPP_

#include <measure>
#include <set>

namespace measurements {

class MeasurementProcessorViews {
public:
	 // general
	static std::string INFRAME_ATTR;

	 // TimeDataFrame
	static std::string TIME_DURATION_ATTR;

	 // MemoryDataFrame
	static std::string MEMORY_DELTA_ATTR;
	static std::string MEMORY_SHU_ATTR;
	static std::string MEMORY_EHU_ATTR;
	static std::string MEMORY_HW_ATTR;

	// CounterDataFrame
	// no specific attrs

	static std::string viewTimeDataFrame ( const MeasurementFrame &, const std::set < std::string > & );
	static std::string viewMemoryDataFrame ( const MeasurementFrame &, const std::set < std::string > & );
	static std::string viewCounterDataFrame ( const MeasurementFrame &, const std::set < std::string > & );
};

}

#endif /* MEASUREMENT_PROCESSOR_VIEWS_HPP_ */
