/*
 * StringFromRawParser.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include <exception/CommonException.h>
#include <string/String.h>
#include <string/StringClasses.h>
#include <alphabet/Symbol.h>
#include <sax/FromXMLParserHelper.h>
#include "StringFromRawParser.h"

namespace string {

String StringFromRawParser::parseString(std::istream_iterator<char>& input) const {
	return parseString(input, std::set<FEATURES>({FEATURES::LINEAR}));
}

String StringFromRawParser::parseString(std::istream_iterator<char>& input, const std::set<FEATURES>& features) const {
	std::vector<alphabet::Symbol> data;
	for(;input != std::istream_iterator<char>(); input++) {
		data.push_back(alphabet::Symbol(*input));
	}
	LinearString < alphabet::Symbol > string { data };

	if(features.count(FEATURES::LINEAR)) return String{string};

	throw exception::CommonException("Invalid input");
}

} /* namespace string */
