#include "TypeTraitsTest.h"
#include <type_traits>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( TypeTraitsTest, "bits" );
CPPUNIT_TEST_SUITE_REGISTRATION( TypeTraitsTest );

void TypeTraitsTest::setUp() {
}

void TypeTraitsTest::tearDown() {
}

void TypeTraitsTest::testIsBaseOf() {
	CPPUNIT_ASSERT( ( std::is_base_of_any<int, int, std::string, TypeTraitsTest::test>::value ) == true );
	CPPUNIT_ASSERT( ( std::is_base_of<int, int>::value ) == true );
	CPPUNIT_ASSERT( ( std::is_base_of<int, std::string>::value ) == false );
	CPPUNIT_ASSERT( ( std::is_base_of<int, TypeTraitsTest::test>::value ) == false );
}

void TypeTraitsTest::testAccessPackElement() {
	CPPUNIT_ASSERT( ( std::is_same< std::get_type_pack_element < 0, int, double >::type, int >::value ) == true );
}

void TypeTraitsTest::testTypeInPack() {
	CPPUNIT_ASSERT( ( std::is_in< int, double, std::set<int>, float, char, int, std::string >::value ) == true );
	CPPUNIT_ASSERT( ( std::is_in< long, double, std::set<int>, float, char, int, std::string >::value ) == false );
}
