/*
 * TreeFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef TREE_FROM_STRING_PARSER_H_
#define TREE_FROM_STRING_PARSER_H_

#include "tree/TreeFeatures.h"
#include "TreeFromStringLexer.h"

#include <set>
#include <tree>
#include <alphabet/Symbol.h>
#include <alphabet/RankedSymbol.h>

namespace tree {

class TreeFromStringParser {
	static std::tree < std::ranked_symbol < DefaultSymbolType > > parseRankedContent ( std::istream &, bool &, std::set < std::ranked_symbol < DefaultSymbolType > > & );
	static std::tree < DefaultSymbolType > parseUnrankedContent ( std::istream &, bool &, std::set < DefaultSymbolType > & );

public:
	static tree::Tree parseTree ( std::istream & );
	static tree::Tree parseTree ( std::istream &, const std::set < FEATURES > & features );
};

} /* namespace tree */

#endif /* TREE_FROM_STRING_PARSER_H_ */
