#include "SymbolTest.h"

#include "alphabet/Symbol.h"

#include "factory/StringDataFactory.hpp"

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))
#define CPPUNIT_EXCLUSIVE_OR(x, y) CPPUNIT_ASSERT((!(x) && (y)) || ((x) && !(y)))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( SymbolTest, "alphabet" );
CPPUNIT_TEST_SUITE_REGISTRATION( SymbolTest );

void SymbolTest::setUp() {
}

void SymbolTest::tearDown() {
}

void SymbolTest::testEqual() {
	{
		std::string input = "a";
		alphabet::Symbol symbol = alib::StringDataFactory::fromString<alphabet::Symbol>(input);

		std::string output = alib::StringDataFactory::toString(symbol);

		CPPUNIT_ASSERT( input == output );

		alphabet::Symbol symbol2 = alib::StringDataFactory::fromString<alphabet::Symbol>(output);

		CPPUNIT_ASSERT( symbol == symbol2 );
	}
	{
		std::string input = "'aaaa'";
		alphabet::Symbol symbol = alib::StringDataFactory::fromString<alphabet::Symbol>(input);

		std::string output = alib::StringDataFactory::toString(symbol);

		CPPUNIT_ASSERT( input == output );

		alphabet::Symbol symbol2 = alib::StringDataFactory::fromString<alphabet::Symbol>(output);

		CPPUNIT_ASSERT( symbol == symbol2 );
	}
	{
		std::string input = "#B";
		alphabet::Symbol symbol = alib::StringDataFactory::fromString<alphabet::Symbol>(input);

		std::string output = alib::StringDataFactory::toString(symbol);

		CPPUNIT_ASSERT( input == output );

		alphabet::Symbol symbol2 = alib::StringDataFactory::fromString<alphabet::Symbol>(output);

		CPPUNIT_ASSERT( symbol == symbol2 );
	}
}

